/**
 * @file PolicyBaseInfo.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

struct PolicyBaseInfo
{
	PolicyBaseInfo()
		: nId(-1), policyId(L""), policyName(L""), policyPrimaryServer(L""),
		dwPolicyFlags(-1), nPrimaryId(-1), nParentPrimaryId(-1), parentPrimaryServer(L""), repDirectParent(L"")
	{
	}
	PolicyBaseInfo(int nId, const std::wstring &policyId, const std::wstring &policyName, const std::wstring &policyPrimaryServer, DWORD dwFlags, int nPrimaryId, int nParentPrimaryId, const std::wstring &parentPrimaryServer, const std::wstring &repDirectParent)
		: nId(nId), policyId(policyId), policyName(policyName), policyPrimaryServer(policyPrimaryServer),
		dwPolicyFlags(dwFlags), nPrimaryId(nPrimaryId), nParentPrimaryId(nParentPrimaryId), parentPrimaryServer(parentPrimaryServer), repDirectParent(repDirectParent)
	{
	}
	PolicyBaseInfo(int nId, const wchar_t *policyId, const wchar_t *policyName, const wchar_t *policyPrimaryServer, DWORD dwFlags, int nPrimaryId, int nParentPrimaryId, const wchar_t *parentPrimaryServer, const wchar_t *repDirectParent)
		: nId(nId), policyId(policyId), policyName(policyName), policyPrimaryServer(policyPrimaryServer),
		dwPolicyFlags(dwFlags), nPrimaryId(nPrimaryId), nParentPrimaryId(nParentPrimaryId), parentPrimaryServer(parentPrimaryServer), repDirectParent(repDirectParent)
	{
	}

	virtual ~PolicyBaseInfo()
	{}

	int nId;
	std::wstring policyId;
	std::wstring policyName;
	std::wstring policyPrimaryServer;
	DWORD dwPolicyFlags;
	int nPrimaryId;
	int nParentPrimaryId;
	std::wstring parentPrimaryServer;
	std::wstring repDirectParent;
};
