/**
 * @file ConsoleHistory.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

class ConsoleHistory
{
	std::vector<std::wstring> Items;

	size_t CurrentIndex;

public:

	ConsoleHistory() : Active(false), CurrentIndex(0) {};

	void Add(std::wstring Line);

	void Load();

	void Save();

	size_t GetCount() const;

	void Clear();

	void GoBegin();

	void GoEnd();

	std::wstring GetNextItem(bool Prior = false);

	bool Active;

	std::wstring FileName;
};

extern ConsoleHistory gCmdHistory;


