/**
 * @file FileLoader.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

class FileLoader
{

public:
	FileLoader(const std::wstring &path);

public:
	std::wstring Load() const;

private:
	std::wstring LoadFromMultiByte(const unsigned int codePage, const char *str, size_t length) const;
	bool HasBom(const std::vector<char> &bomBytes, const std::vector<char> &fileBytes) const;

private:

	const std::wstring path;

	std::vector<char> bomBytes_utf16;
	std::vector<char> bomBytes_utf8;

};

