/**
 * @file Token.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

class Token
{
public:
	enum TokenType
	{
		token_text,
		token_comma,
		token_par_left,
		token_par_right,

		// operators with single operand - before operand
		token_operators_start,	// not used, only for comparing
		token_operators1_start,	// not used, only for comparing
		token_memberof,
		token_policyis,
		token_operators1_end,	// not used, only for comparing

		// operators with two operands
		token_operators2_start,	// not used, only for comparing
		token_equals,
		token_notequals,
		token_greater,
		token_less,
		token_greaterequal,
		token_lessequal,
		token_like,
		token_notlike,
		token_operators2_end,	// not used, only for comparing

		// operators with single operand - after operand
		token_operators3_start,	// not used, only for comparing
		token_asc,
		token_desc,
		token_in, // the second operand (in parentheses) is handled separately
		token_notin, // the second operand (in parentheses) is handled separately
		token_operators3_end,	// not used, only for comparing

		token_operators_end,		// not used, only for comparing
	};
	static std::wstring GetTokenTypeAsString(TokenType type);

	Token(const std::wstring &tokenText, Token::TokenType tokenType);
	std::wstring text;
	TokenType type;
};


std::wstring TokenArrayToString(tokenArray::iterator beginIt, tokenArray::iterator endIt);
