/**
 * @file Command_ClientDelete.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_ClientDelete.h"

#include <Common/era_api/era_api.h>
#include <Common/era_api/err_codes.h>
#include <Common/scope_exit.h>
#include "../Element.h"
#include "../util/apiUtils.h"
#include "../EracmdExceptions.h"

void Command_ClientDelete::Execute(elementArray &elements, OutputHandler &out)
{
	std::shared_ptr<Element> clientList = GetArgument(0);
	std::vector<const ElementWord *> clientIdWords = clientList->GetWords();
	if ((clientIdWords.size() == 1) && (::_wcsicmp(clientIdWords[0]->GetString().c_str(), L"*") == 0))
	{
		throw EraCMDException(CMDERROR_NUMBER_EXPECTED_IN_ID_LIST, L"*");
	}

	Era_ClientList *clients = ElementToClientList(GetArgument(0));
	scope_exit se_clients(std::bind(era_ClientList_delete, clients));

	// 2nd parameter
	bool noWait = (GetArgument(1)!=NULL);

	uint32_t result_clientNew = era_Client_delete(clients, noWait);
	if (result_clientNew != 0)
	{
		throw EraCMDException_FromApi(result_clientNew);
	}
}

