/**
 * @file Command_GetData.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include <Common/era_api/era_api.h>
#include <Common/scope_exit.h>
#include <Common/era_api/err_codes.h>
#include "Command_GetData.h"
#include "../EracmdExceptions.h"
#include "../Element.h"
#include "../util/apiUtils.h"
#include "../util/stringUtils.h"

void Command_GetData::Execute(elementArray& elements, OutputHandler& out)
{
	std::wstring type = GetArgument(0)->GetString();
	DWORD dataType = 0;

	if (_wcsicmp(type.c_str(), L"sysinspector") == 0)
		dataType = ERA_DATA_SYSINSPECTOR;
	else
	if (_wcsicmp(type.c_str(), L"configuration") == 0)
		dataType = ERA_DATA_CONFIGURATION;
	else
	if (_wcsicmp(type.c_str(), L"protection_status") == 0)
		dataType = ERA_DATA_STATUS;
	else
	if (_wcsicmp(type.c_str(), L"protection_features") == 0)
		dataType = ERA_DATA_FEATURES;
	else
	if (_wcsicmp(type.c_str(), L"system_information") == 0)
		dataType = ERA_DATA_SYSTEM_INFORMATION;
	else
	if (_wcsicmp(type.c_str(), L"policy") == 0)
		dataType = ERA_DATA_POLICY;
	else
	if (_wcsicmp(type.c_str(), L"policy_merged") == 0)
		dataType = ERA_DATA_POLICY_MERGED;
	else
	if (_wcsicmp(type.c_str(), L"policy_override") == 0)
		dataType = ERA_DATA_POLICY_OVERRIDE;
	else
	if (_wcsicmp(type.c_str(), L"policy_nonoverride") == 0)
		dataType = ERA_DATA_POLICY_NONOVERRIDE;
	else
		throw EraCMDException(CMDERROR_UNKNOWN_DATA_TYPE_REQUESTED, type.c_str());

	std::wstring dataIDstr = GetArgument(1)->GetString();
	DWORD dataID = 0;
	try
	{
		dataID = WstringToInt(dataIDstr);
	} catch (...)
	{
		throw EraCMDException(CMDERROR_INVALID_PARAMETER, dataIDstr.c_str());
	}

	std::wstring localFilePath = GetArgument(2)->GetString().c_str();
	DWORD rc = era_GetData(dataType, dataID, localFilePath.c_str());
	if (rc != 0)
	{
		throw EraCMDException_FromApi(rc);
	}
}

