/**
 * @file Command_GroupExport.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_GroupExport.h"

#include <Common/era_api/err_codes.h>
#include "../util/stringUtils.h"
#include "../Element.h"
#include "../EracmdExceptions.h"

void Command_GroupExport::Execute(elementArray &elements, OutputHandler &out)
{
	std::wstring groupType = GetArgument(0)->GetString();
	bool parametric = (_wcsicmp(groupType.c_str(), L"parametric") == 0);

	std::wstring groupIdStr = GetArgument(1)->GetString();
	uint32_t groupId = 0;
	if (groupIdStr != L"*")
	{
		try
		{
			groupId = ::WstringToUint(groupIdStr);
			if (groupId == 0) throw 0;
		}
		catch (...)
		{
			throw EraCMDException(CMDERROR_NUMBER_EXPECTED_FOR_GROUP_ID, groupIdStr.c_str());
		}
	}

	std::wstring file = GetArgument(2)->GetString();

	std::wstring tree;
	if (std::shared_ptr<Element> arg = GetArgument(3))
		tree = arg->GetString();

	uint32_t result = era_Group_export(groupId, _wcsicmp(tree.c_str(), L"FALSE") != 0, file.c_str(), parametric);
	if (result != 0)
		throw EraCMDException_FromApi(result);
}

