/**
 * @file Command_PolicyAssign.cpp
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_PolicyAssign.h"

#include <Common/era_api/era_api.h>
#include <Common/era_api/err_codes.h>
#include <Common/scope_exit.h>
#include "../util/apiUtils.h"
#include "../EracmdExceptions.h"

void Command_PolicyAssign::Execute(elementArray &elements, OutputHandler &out)
{
	// policy id
	int policyId;
	std::wstring policyIdArg = GetArgumentAsString(0);
	if (_wcsicmp(policyIdArg.c_str(), L"!defaultclientspolicy") == 0)
		policyId = 0;
	else
		policyId = GetNumParam(0);

	// clients
	Era_ClientList *clients = ElementToClientList(GetArgument(1));
	scope_exit se_clients(std::bind(era_ClientList_delete, clients));

	uint32_t result = era_Policy_assign(policyId, clients);
	if (result != 0)
		throw EraCMDException_FromApi(result);
}
