/**
 * @file Command_PolicyRuleDelete.cpp
 * @author Copyright (c) 2014 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "Command_PolicyRuleDelete.h"

#include <Common/era_api/err_codes.h>
#include "../util/stringUtils.h"
#include "../Element.h"
#include "../EracmdExceptions.h"

void Command_PolicyRuleDelete::Execute(elementArray &elements, OutputHandler &out)
{
	uint32_t deletedPolicyRuleId = 0;
	{
		const std::wstring elementStr = GetArgument(0)->GetString();

		try
		{
			deletedPolicyRuleId = ::WstringToUint(elementStr);
		}
		catch (...)
		{
			throw EraCMDException(CMDERROR_NUMBER_EXPECTED_FOR_POLICY_RULE_ID, elementStr.c_str());
		}
	}

	uint32_t result_policyRuleDelete = era_PolicyRule_delete(deletedPolicyRuleId);
	if (result_policyRuleDelete != 0)
	{
		throw EraCMDException_FromApi(result_policyRuleDelete);
	}
}

