/**
 * @file CommandFlags.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

struct CommandFlags
{

	CommandFlags();

	enum OuputFormatting
	{
		FORMAT_CSV,
		FORMAT_TABLE,
	};

	enum Encoding
	{
		ENCODING_ANSI,
		ENCODING_UTF8,
		ENCODING_UTF16,
	};

	enum OutputMode
	{
		MODE_OVERWRITE,
		MODE_APPEND,
	};

	enum HeaderType
	{
		HEADER_KEYWORD,
		HEADER_PRETTY,
		HEADER_NONE,
	};

	enum FieldFormatting
	{
		FIELD_PRETTY,
		FIELD_KEYWORD,
	};

	bool checkOnly;
	bool continueOnError;

	bool paged;

	bool tableClip;
	bool color;

	OuputFormatting outputFormatting;
	wchar_t outputCSVDelimiter;

	std::wstring outputFilePath;
	Encoding outputEncoding;
	OutputMode outputMode;

	std::wstring logFilePath;
	Encoding logEncoding;

	HeaderType headerType;

	FieldFormatting fieldFormatting;

#ifdef _DEBUG
	friend std::wostream& operator<<(std::wostream &os, const CommandFlags &cf);
#endif
};

