/**
 * @file OutputFormatter_Table.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

#include "../console_colors/ConsoleColors_Win.h"
#include "OutputFormatter.h"

class OutputFormatter_Table : public OutputFormatter
{

public:
	OutputFormatter_Table(ConsoleColors_Win &consoleColors);

	virtual void Print(TableReader &reader, std::wostream &out, const CommandFlags::HeaderType headerType, DWORD screenWidth, const TextWidth &textWidth) override;

private:
	void PrintSeparator(const std::vector<std::wstring::size_type> &maxLengths, std::wostream &out, const TextWidth &textWidth);
	void PrintRow(const std::vector<std::wstring::size_type> &maxLengths, const StringVector &texts, std::wostream &out, const bool isHeader, const Color &lineColor, const Color &pipeColor, const Color &pipeColorBorder, const TextWidth &textWidth);
	inline StringVector::size_type MaxLengthToColumnWidth(const StringVector::size_type maxLength);
	DWORD PrintClippedString(std::wostream &out, const std::wstring &str, DWORD actualWidth, const TextWidth &textWidth);

private:
	static void AddMax(std::vector<std::wstring::size_type> &maxLengths, const size_t column, const std::wstring::size_type length);

private:
	ConsoleColors_Win &consoleColors;
	DWORD consoleWidth; // if 0, then there is no limit
};

