/**
 * @file OutputHandler.h
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#pragma once

struct CommandFlags;
class TableReader;

#include "../console_colors/ConsoleColors_Win.h"
#include "OutputFormatter.h"
#include "TextWidth.h"

class OutputHandler
{
public:
	OutputHandler(const CommandFlags &commandFlags, ConsoleColors_Win &consoleColors, const TextWidth &width_console, const TextWidth &width_file);
	~OutputHandler();

	void Print(TableReader &reader);
	void PrintRaw(const std::wstring &str);
	SHORT GetScreenWidth() const;
private:
	static void ConvertStr(const std::wstring &str, unsigned int codePage, std::vector<char> &bytes);

	std::unique_ptr<OutputFormatter> outputFormatter;
	std::ios_base *outputStream;
	unsigned int codePage;
	bool convert;
	CommandFlags::HeaderType headerType;
	bool pagedOutput;
	bool tableClip;

	const TextWidth &width_console;
	const TextWidth &width_file;
};
