/**
 * @file apiUtils.cpp
 * @author Copyright (c) 2013 ESET, spol. s r.o.
 */

#include "set_nod.h"
#include "apiUtils.h"

#include <Common/era_api/era_api.h>
#include <Common/era_api/err_codes.h>
#include "../Element.h"
#include "../EracmdExceptions.h"
#include "StringUtils.h"

Era_ClientList *ElementToClientList(std::shared_ptr<Element> clientList)
{
	Era_ClientList *params = era_ClientList_new();

	std::vector<const ElementWord *> clientIdWords = clientList->GetWords();
	if ((clientIdWords.size() == 1) && (::_wcsicmp(clientIdWords[0]->GetString().c_str(), L"*") == 0))
	{
		era_ClientList_SetAllClients(params);
	}
	else
	{
		for (std::vector<const ElementWord *>::const_iterator it = clientIdWords.begin(); it != clientIdWords.end(); ++it)
		{
			std::wstring idStr = (*it)->GetString();

			int id = 0;
			try
			{
				id = WstringToUint(idStr);
			} catch (...)
			{
				era_ClientList_delete(params);
				throw EraCMDException(CMDERROR_NUMBER_EXPECTED_IN_ID_LIST, idStr.c_str());
			}
			era_ClientList_AddClient(params, id);
		}
	}
	return params;
}
